/********************************************************
 * File: smtok.h (Listing 5)
 * Title: Token set
 * Author: Allen Holub
 ********************************************************/

typedef enum token
{
    NO_TOKEN    = -1,   /* Three values that can not also be tokens. Also, */
    NO_TOKEN2   = -2,   /* may not be a valid index into the state table.  */
    NO_TOKEN3   = -3,
    END_OF_FILE = 0,    /* end of file returned from scanner, must be 0.   */
    ACCEPT,             /* accept                                          */
    CHARACTER,          /* any single character that isn't part of a token */
    CLOSE_BRACKET,      /* ]                                               */
    CLOSE_PAREN,        /* )                                               */
    CODE,               /* all text up to the next level-0 close curly     */
    DASH,               /* -                                               */
    COLON,              /* :                                               */
    GOTO,               /* goto                                            */
    LOOP,               /* loop                                            */
    NUMBER,             /* 1234                                            */
    NOT,                /* !                                               */
    ON,                 /* on                                              */
    OPEN_BRACKET,       /* [                                               */
    OPEN_PAREN,         /* (                                               */
    STATE               /* state                                           */
}
token;

